package cn.com.qmth.sdk.security;

import java.util.Map;

import org.apache.commons.io.IOUtils;
import org.apache.http.HttpStatus;

import com.google.common.collect.Maps;

import cn.com.qmth.sdk.exception.StatusException;
import cn.com.qmth.sdk.security.bean.Session;
import cn.com.qmth.sdk.support.StatusResponse;
import cn.com.qmth.sdk.util.HttpMethod;
import cn.com.qmth.sdk.util.JsonUtil;
import cn.com.qmth.sdk.util.OKHttpUtil;
import cn.com.qmth.sdk.util.PropertiesUtil;
import cn.com.qmth.sdk.util.QmthUtil;
import okhttp3.Response;

/**
 * 登陆
 *
 * @author WANGWEI
 * @date 2019年5月8日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class LoginUtil {

	public static Session login(String loginName, String password) {

		Long rootOrgId = QmthUtil.getRootOrgId();
		String url = PropertiesUtil.getString("qmth.loginUrl");

		Map<String, String> params = Maps.newHashMap();
		params.put("rootOrgId", String.valueOf(rootOrgId));
		params.put("loginName", loginName);
		params.put("password", password);

		Response resp = null;
		try {
			resp = OKHttpUtil.call(HttpMethod.POST, url, Maps.newHashMap(), params);
			int code = resp.code();
			String body = resp.body().string();
			System.out.println(code);
			System.out.println(body);
			if (HttpStatus.SC_OK != code) {
				StatusResponse sr = JsonUtil.fromJson(body, StatusResponse.class);
				throw new StatusException(sr.getCode(), sr.getDesc());
			}
			Session session = JsonUtil.fromJson(body, Session.class);
			return session;
		} catch (StatusException e) {
			throw e;
		} catch (Exception e) {
			throw new RuntimeException(e);
		} finally {
			IOUtils.closeQuietly(resp);
		}
	}

}
